 ###############################################
#                                               #
#              M E D I A D I C O                #
#       v2.5 (04/07/2008)  par MenzAgitat       #
#                                               #
#          http://www.boulets-roxx.com          #
#        IRC:  irc.teepi.net    #boulets        #
#              irc.epiknet.org  #boulets        #
#                                               #
#     Mes scripts sont tlchargeables sur      #
#            http://www.egghelp.org             #
#        et  http://www.eggdrop.fr              #
#                                               #
 ###############################################
#
# Inspir du script Dictionnaire de Regis Damongeot (regis@regis.no-ip.com) / Auberdjin / Alien57
# Ce script utilise une procdure du script TkTiny crit par Tomekk (tomekk@oswiecim.eu.org)
# Merci  Galdinx pour le coup de main avec la procdure de sortie.


# Description:
# Ce script permet d'afficher la dfinition d'un mot franais
# en tapant !dico <mot>

# Changelog:
# 1.0: Premire version fonctionnelle. (par Regis Damongeot)
# 1.1: - Changement de l'url du site web utilis. (par Regis Damongeot)
#      - Amliorations diverses. (par Auberdjin et Alien57)
# 2.0: - Rcriture de la plupart du code par MenzAgitat.
#      - Wikipedia a t remplac par Mediadico
#      - Le script a t renomm en "MediaDico"
#      - Si une dfinition est trop longue, elle sera tronque et un lien
#        sera donn pour lire la suite.
#      - Adaptation du script TkTiny par Tomekk pour afficher des TinyURLs.
# 2.1  - Un paramtre a t ajout pour limiter le fonctionnement du
#        dictionnaire  certains chans seulement.
#      - Le mot et sa dfinition sont maintenant affichs sur la mme ligne.
# 2.2  - Amliorations visuelles, correction des regsub.
# 2.3  - Meilleure gestion des exceptions.
# 2.4  - Rparation du script suite  un changement de la mise en page du
#        site web duquel les dfinitions sont rcupres.
#      - Amlioration de la prsentation des dfinitions.
#      - Le dictionnaire suggre des alternatives en cas de mot mal orthographi
#        ou inconnu.
#      - Il est maintenant possible de limiter le nombre de paragraphes
#        affichs, le nombre de lignes par paragraphe et le nombre maximum
#        de caractres par ligne.
#      - Timeouts paramtrables pour la dfinition et la conversion TinyURL.
#      - Amlioration de la gestion des exceptions (problmes de version
#        d'eggdrop, de version de Tcl, mauvais rglages des paramtres du
#        script, ...)
#      - Amlioration de la scurit du script.
#      - Intgration du script dans un namespace pour une meilleure gestion des
#        ressources et une meilleure compatibilit avec les autres scripts.
#      - Mise  jour de la procdure TinyURL d'aprs la dernire version de
#        TkTiny par Tomekk (v0.5).
#      - Rcriture par Galdinx de la procdure de sortie (plus propre, plus optimis)
# 2.5	 - Correction de la gestion d'une exception qui survient parfois lorsque la
#				 rcupration de la dfinition choue.
#			 - On peut maintenant demander la dfinition d'un mot en priv avec le bot
#				 au moyen de la commande (par dfaut)  /msg NomDuBot !dico mot
#			 - quelques putserv changs en puthelp car plus adapts

#LICENCE:
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
if { [lindex [split $version] 1] < 1061800 } { putlog "\00304\002\[MediaDico - ERREUR\]\002\003 La version de votre eggdrop est \00304\002[lindex [split $version] 0]\002\003; Mediadico.tcl ne fonctionnera correctement que sur les eggdrops version 1.6.18 ou suprieure." ; return }
if { $tcl_version < 8.4 } { putlog "\00304\002\[MediaDico - ERREUR\]\002\003 Mediadico.tcl ncessite que Tcl 8.4 (ou plus) soit install pour fonctionner. Votre version actuelle de Tcl est \00304\002$tcl_version\002\003." ; return }
if {[info commands mediadico::uninstall] eq "::mediadico::uninstall"} { mediadico::uninstall }
namespace eval mediadico {


	###########################
	#				PARAMETRES        #
	###########################

	# Chans sur lesquels Mediadico sera actif (spars par un espace)
	# Remarque : attention aux majuscules, le nom du chan est sensible  la casse
	variable mediadicochans "#votrechan"

	# Activer la commande prive ? (1 = oui ; 0 = non)
	# Si la commande prive est active, les utilisateurs pourront demander
	# la dfinition d'un mot en priv avec le bot en tapant (par dfaut)
	# /msg NomDuBot !dico mot
	variable private_mode 1
	
	# Commande publique
	variable public_cmd "!dico"
	# Commande prive
	variable private_cmd "!dico"

	# Autorisations pour la commande publique
	variable public_cmd_auth "-|-"
	# Autorisations pour la commande prive
	variable private_cmd_auth "-|-"

	# Nombre de paragraphes maximum  afficher
	# Note : Chaque sens d'un mot compte comme un paragraphe,
	#        de mme que les "Difficults orthographiques", les
	#        "Homonymes - paronymes", les "Suggestions" ...
	# Remarque : une valeur leve peut provoquer du flood
	variable paragraphs 4

	# Nombre de lignes maximum  afficher dans chaque paragraphe.
	# Remarque : une valeur leve peut provoquer du flood.
	variable lines_per_paragraph 2

	# Nombre de caractres maximum par ligne (la limite peut varier d'un serveur
	# IRC  un autre); si la fin des lignes est tronque, cela signifie que vous
	# devez diminuer cette valeur.
	variable max_line_length 420
	
	# Aprs combien de secondes dcide-t-on que le site web utilis par le script
	# pour afficher les dfinitions est offline (ou trop lent) en l'absence de
	# rponse de sa part ?
	variable dico_timeout 10
	
	# Aprs combien de secondes dcide-t-on que le site web www.tinyurl.com est
	# offline (ou trop lent) en l'absence de rponse de sa part ?
	# Remarque : en cas de timeout, l'URL intgrale sera affiche  la place
	# de la TinyURL.
	variable TinyURL_timeout 5



####################################################################
#                                                                  #
# NE MODIFIEZ RIEN APRES CE CADRE SI VOUS NE CONNAISSEZ PAS LE TCL #
#                                                                  #
#   DO NOT MODIFY ANYTHING BELOW THIS BOX IF YOU DON'T KNOW TCL    #
#                                                                  #
####################################################################

	package require Tcl 8.4
	package require http
	variable scriptname "Mediadico"
	variable version "2.5.04072008"
	variable useragent "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.1) Gecko/20071128 Firefox/2.0.0.11"
	variable site_URL "http://dictionnaire.tv5.org/dictionnaires.asp?Action=1&mot=\$arg&che=1"
	bind pubm $mediadico::public_cmd_auth "* %$mediadico::public_cmd *" { mediadico::dico $_pubm1 $_pubm2 $_pubm3 $_pubm4 $_pubm5 ; # }
	bind pubm $mediadico::public_cmd_auth "* %$mediadico::public_cmd" { mediadico::syntax $_pubm1 $_pubm2 $_pubm3 $_pubm4 $_pubm5 ; # }
	if {$mediadico::private_mode} {
		bind msgm $mediadico::private_cmd_auth "%$mediadico::private_cmd *" { mediadico::dico $_msgm1 $_msgm2 $_msgm3 private $_msgm4 ; # }
		bind msgm $mediadico::private_cmd_auth "%$mediadico::private_cmd" { mediadico::syntax $_msgm1 $_msgm2 $_msgm3 private $_msgm4 ; # }
	}

# bind pub n|-  ${trigger}join {dojoin $_pub1 $_pub5; return 1; #}
# bind msg n ${trigger}join {dojoin $_msg1 $_msg4; #}


	bind evnt - prerehash mediadico::uninstall 
	proc uninstall {args} {
		putlog "Dsallocation des ressources de \002Mediadico...\002"
		catch { unbind pubm $mediadico::public_cmd_auth "* %$mediadico::public_cmd *" { mediadico::dico $_pubm1 $_pubm2 $_pubm3 $_pubm4 $_pubm5 ; # }}
		catch { unbind pubm $mediadico::public_cmd_auth "* %$mediadico::public_cmd" { mediadico::syntax $_pubm1 $_pubm2 $_pubm3 $_pubm4 $_pubm5 ; # }}
		catch { unbind msgm $mediadico::private_cmd_auth "%$mediadico::private_cmd *" { mediadico::dico $_msgm1 $_msgm2 $_msgm3 private $_msgm4 ; # }}
		catch { unbind msgm $mediadico::private_cmd_auth "%$mediadico::private_cmd" { mediadico::syntax $_msgm1 $_msgm2 $_msgm3 private $_msgm4 ; # }}
		catch { unbind evnt - prerehash mediadico::uninstall }
		namespace delete ::mediadico
	}
	# Vrification de la validit des chans dfinis
	foreach element $mediadico::mediadicochans {
		if {[lsearch [channels] $element] == -1} {
			putlog "\00304\002\[MediaDico - ERREUR\]\002\003 Le chan \00307\002$element\002\003 spcifi dans la configuration de MediaDico ne fait pas partie des salons sur lesquels je me trouve. \037Attention\037, le nom des salons est sensible  la casse. Veillez  respecter les minuscules/majuscules."
			putlog "\00304\002\[MediaDico - INFO\]\002\003 Voici la liste des salons sur lesquels je me trouve actuellement : \00314[channels]"
		} 	
	}
}

# Syntaxe
proc mediadico::syntax {nick host hand chan arg} {
	if {$chan eq "private"} {set chan $nick}
	puthelp "privmsg $chan :\037Syntaxe :\037 \002$mediadico::public_cmd\002 \00314<\003mot\00314> \00307| \003Cherche la dfinition d'un mot dans le dictionnaire."
	return
}

# Procdure principale
proc mediadico::dico {nick host hand chan arg}  {
	if {$chan eq "private"} {set chan $nick}
	if {([lsearch -exact $mediadico::mediadicochans $chan] == -1) && ($chan ne $nick)} { return }
	regsub -all -- {\003[0-9]{0,2}(,[0-9]{0,2})?|\017|\037|\002|\026|\006|\007} [lrange [split $arg] 1 end] "" arg
	if {[llength [split $arg]] != 1} {
		puthelp "privmsg $chan :\00314Vous ne pouvez chercher qu'un seul mot  la fois.\003"
		return
	} else {
		set token [::http::config -useragent $mediadico::useragent]
		set token [::http::geturl [subst $mediadico::site_URL] -timeout [expr $mediadico::dico_timeout * 1000]]
		if {[::http::status $token] eq "ok"} {
			regexp "<small>(.+?)</div>" [::http::data $token] res
			if {![string match -nocase "*<div id='lexphon'>*" $res]} { regexp "<small>(.+?)</small>" $res res }
			if { $res ne "" && [lsearch -exact [split $res] "color='#911409'>Lexique"] == -1 } {
				# set fichiertest [open "scripts/test.txt" w]
				# puts $fichiertest "---------------------------- DONNEES BRUTES"
				# puts $fichiertest $res
				# close $fichiertest
				regsub -all {\n} $res " " res
				regsub -all {<small> <FONT COLOR=BLACK><B>>} $res "\002" res
				regsub -all {<BR><BR> <FONT COLOR=BLACK><B>>} $res "<BR><BR>\002" res
				regsub -all {</B></FONT><BR><B>} $res "" res
				regsub -all {</B></FONT><BR> <FONT COLOR=RED>} $res " <FONT COLOR=RED>" res
				regsub -all -nocase {<B>Homonymes - paronymes :</B>(.+?)<BR>} $res "\037Homonymes - paronymes\037 :" res
				regsub -all {\.</FONT><BR> \(} $res ". (" res
				regsub -all {</B></FONT><BR>} $res "\003" res
				regsub -all {<FONT COLOR=RED>} $res "\002\00314" res
				regsub -all {</FONT><BR> </FONT><BR> <BR><BR>} $res "\n" res
				regsub -all {</FONT><BR> </FONT><BR><BR>} $res "\n" res
				regsub -all {<BR><BR>} $res "\n" res
				regsub -all {\)</FONT><BR>} $res ")</FONT>" res
				regsub -all {\)</FONT>} $res "\)\003 :" res
				regsub -all {:</FONT><BR>} $res ":</FONT>" res
				regsub -all {<BR>} $res "\00307 | \003" res
				regsub -all "&#160;" $res " " res 
				regsub -all -nocase "<font color='#FFFFFF'> - </font>" $res "" res 
				regsub -all {<[^<]*>} $res "" res
				regsub -all -nocase "[mediadico::accents $arg]\(.+?\)le dictionnaire multifonctions vous propose...\(.+?\)&#149;" $res "\00314Impossible de trouver une dfinition.\003 \00307|\003 \037Suggestions\037 : " res
#  			regsub -all -nocase {(.+?)la barre d'outil du dictionnaire multifonctions (.+?)} $res "\00314La rcupration de la dfinition a chou. Veuillez ritrer votre demande.\003" res
				if {[string match -nocase "*la barre d'outil du dictionnaire multifonctions*" $res]} { set res "\00314La rcupration de la dfinition a chou. Veuillez ritrer votre demande.\003" }
				regsub -all "&#149;" $res "\00307-\003" res 
				regsub -all {\ +} $res " " res
				set res [mediadico::filter $res]
				regsub -all -nocase {Difficults orthographiques} $res "\037Difficults orthographiques\037" res
				set elements [expr [regexp -all -- {\n} $res] + 1] 
				set res [split $res "\n"]
				set nbpar [llength $res]
				set result {} 
				set counter_para 1
				foreach res_section $res {
					if {($counter_para == $mediadico::paragraphs) && ($counter_para != $nbpar)} {
						append res_section " \00304(...)\003"
					}
					set output_length [string length $res_section]
					set counter_line 1
					set counter_letter 0
					while {$counter_letter < $output_length} {
						if {$output_length - $counter_letter > $mediadico::max_line_length} { 
							set index [string last " " $res_section [expr $counter_letter + $mediadico::max_line_length ]]
						} else {
							set index $output_length 
						}
						if {($counter_line == $mediadico::lines_per_paragraph) && ($index != $output_length) } {
							lappend result [string replace [set range [string range $res_section $counter_letter $index]] [string last " " $range] end " \00304(...)\003"]
							set tobecontinued 1
							break                        
						} else {
							lappend result [string range $res_section $counter_letter $index]
							incr counter_line
						}
						set counter_letter $index
					}
					if {($counter_para == $mediadico::paragraphs) && ($counter_para != $nbpar)} {
						set tobecontinued2 1
						break                        
					} else {
						incr counter_para
					}
				}
				foreach line $result {
					if {[string trim $line] ne "" && [string trim $line] ne " "} {
						puthelp "privmsg $chan :$line"
					}
				}
				if { ([info exists tobecontinued]) || ([info exists tobecontinued2]) } {
					set tinyURL [mediadico::tinyurl_conversion [subst $mediadico::site_URL]]
					puthelp "privmsg $chan :\00314Vous pouvez consulter la dfinition intgrale ici : \00312\037$tinyURL\037\003"
				}
			} else {
				puthelp "privmsg $chan :\00314Impossible de trouver une dfinition\003"
			}
		} else {
			puthelp "privmsg $chan :\00314La connexion au dictionnaire n'a pu s'tablir. Peut-tre le site rencontre-t-il des difficults techniques. Veuillez ressayer plus tard.\003"
		}
		::http::cleanup $token
	}
}

# Conversion de l'URL en une version plus courte (d'aprs le script
# tktiny-0.5.tcl de Tomekk )
# Remarque : aprs un timeout de 10 secondes, l'URL originale est
# donne par dfaut)
proc mediadico::tinyurl_conversion { url } {
	set url [split [string map -nocase {
		"&amp;"		"&"
	} $url]]
	set tiny_form "http://tinyurl.com/create.php"
	set tiny_token [http::config -useragent $mediadico::useragent]
	set tiny_token [http::geturl $tiny_form -query [http::formatQuery "url" $url] -timeout [expr $mediadico::TinyURL_timeout * 1000]]
	set html_data [http::data $tiny_token]
	set all_n [split $html_data "\n"]
	set tiny_link ""
	foreach tiny_lines $all_n {
		if {[regexp -all -nocase "name\=tinyurl" $tiny_lines]} {
			regsub -all -nocase "<input type=hidden name=tinyurl value=\"" $tiny_lines "" tiny_link
			regsub -all -nocase "\">" $tiny_link "" tiny_link
		}
	}
	if {($tiny_link != 0) && ($tiny_link ne "")} {
		return $tiny_link
	} {
		return "${url}"
	}
}

##### suppression des accents
proc mediadico::accents {text} {
	return [string map -nocase {
		"" "a" "" "a" "" "a"
		"" "e" "" "e" "" "e" "" "e"
		"" "i" "" "i"
		"" "o" "" "o"
		"" "u" "" "u" "" "u"
		"" "c" "" "n" "" "a" "" "o"
	} $text]
}

##### Conversion des caractres html spciaux
proc mediadico::filter {res} {
	set res [string map {
		"&agrave;"		""		"&agrave;"		""		"&aacute;"		""		"&acirc;"			""
		"&atilde;"		""		"&auml;"			""		"&aring;"			""		"&aelig;"			""
		"&ccedil;"		""		"&egrave;"		""		"&eacute;"		""		"&ecirc;"			""
		"&euml;"			""		"&igrave;"		""		"&iacute;"		""		"&icirc;"			""
		"&iuml;"			""		"&eth;"				""		"&ntilde;"		""		"&ograve;"		""
		"&oacute;"		""		"&ocirc;"			""		"&otilde;"		""		"&ouml;"			""
		"&divide;"		""		"&oslash;"		""		"&ugrave;"		""		"&uacute;"		""
		"&ucirc;"			""		"&uuml;"			""		"&yacute;"		""		"&thorn;"			""
		"&yuml;"			""		"&quot;"			"\""	"&amp;"				"&"		"&euro;"			""
		"&oelig;"			""		"&Yuml;"			""		"&nbsp;"			" "		"&iexcl;"			""
		"&cent;"			""		"&pound;"			""		"&curren;"		""		"&yen;"				""
		"&brvbar;"		""		"&brkbar;"		""		"&sect;"			""		"&uml;"				""
		"&die;"				""		"&copy;"			""		"&ordf;"			""		"&laquo;"			""
		"&not;"				""		"&shy;"				"-"	"&reg;"				""		"&macr;"			""
		"&hibar;"			""		"&deg;"				""		"&plusmn;"		""		"&sup2;"			""
		"&sup3;"			""		"&acute;"			""		"&micro;"			""		"&para;"			""
		"&middot;"		""		"&cedil;"			""		"&sup1;"			""		"&ordm;"			""
		"&raquo;"			""		"&frac14;"		""		"&frac12;"		""		"&frac34;"		""
		"&iquest;"		""		"&Agrave;"		""		"&Aacute;"		""		"&Acirc;"			""
		"&Atilde;"		""		"&Auml;"			""		"&Aring;"			""		"&AElig;"			""
		"&Ccedil;"		""		"&Egrave;"		""		"&Eacute;"		""		"&Ecirc;"			""
		"&Euml;"			""		"&Igrave;"		""		"&Iacute;"		""		"&Icirc;"			""
		"&Iuml;"			""		"&ETH;"				""		"&Dstrok;"		""		"&Ntilde;"		""
		"&Ograve;"		""		"&Oacute;"		""		"&Ocirc;"			""		"&Otilde;"		""
		"&Ouml;"			""		"&times;"			""		"&Oslash;"		""		"&Ugrave;"		""
		"&Uacute;"		""		"&Ucirc;"			""		"&Uuml;"			""		"&Yacute;"		""
		"&THORN;"			""		"&szlig;"			""		"\r"					"\n"	"\t"					""
		"&#039;"			"\'"	"&#39;"				"\'"
		"&#34;"				"\'"	"&#38;"				"&"		"#91;"				"\("	"&#92;"				"\/"
		"&#93;"				")"		"&#123;"			"("		"&#125;"			")"		"&#163;"			""
		"&#168;"			""		"&#169;"			""		"&#171;"			""		"&#173;"			""
		"&#174;"			""		"&#180;"			""		"&#183;"			""		"&#185;"			""
		"&#187;"			""		"&#188;"			""		"&#189;"			""		"&#190;"			""
		"&#192;"			""		"&#193;"			""		"&#194;"			""		"&#195;"			""
		"&#196;"			""		"&#197;"			""		"&#198;"			""		"&#199;"			""
		"&#200;"			""		"&#201;"			""		"&#202;"			""		"&#203;"			""
		"&#204;"			""		"&#205;"			""		"&#206;"			""		"&#207;"			""
		"&#208;"			""		"&#209;"			""		"&#210;"			""		"&#211;"			""
		"&#212;"			""		"&#213;"			""		"&#214;"			""		"&#215;"			""
		"&#216;"			""		"&#217;"			""		"&#218;"			""		"&#219;"			""
		"&#220;"			""		"&#221;"			""		"&#222;"			""		"&#223;"			""
		"&#224;"			""		"&#225;"			""		"&#226;"			""		"&#227;"			""
		"&#228;"			""		"&#229;"			""		"&#230;"			""		"&#231;"			""
		"&#232;"			""		"&#233;"			""		"&#234;"			""		"&#235;"			""
		"&#236;"			""		"&#237;"			""		"&#238;"			""		"&#239;"			""
		"&#240;"			""		"&#241;"			""		"&#242;"			""		"&#243;"			""
		"&#244;"			""		"&#245;"			""		"&#246;"			""		"&#247;"			""
		"&#248;"			""		"&#249;"			""		"&#250;"			""		"&#251;"			""
		"&#252;"			""		"&#253;"			""		"&#254;"			""
	} $res]
	set res [string map -nocase {
		"&lt;"				"<"		"&gt;"				">"
	} $res]
	set res [encoding convertfrom "utf-8" $res ]
	return "${res}"
}

putlog "\002*MediaDico v$mediadico::version*\002 par MenzAgitat ( \037\00312http://www.boulets-roxx.com\003\037 ) a t charg."
